Index: /branches/VRP/HeuristicLab 3.3.sln
===================================================================
--- /branches/VRP/HeuristicLab 3.3.sln	(revision 6092)
+++ /branches/VRP/HeuristicLab 3.3.sln	(revision 6093)
@@ -26,6 +26,4 @@
 EndProject
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.ALGLIB", "HeuristicLab.ALGLIB", "{F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.ALGLIB-2.5.0", "HeuristicLab.ALGLIB-2.5.0", "{F1A195C9-98CD-47C6-9B74-3344EB258C5D}"
 EndProject
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.LibSVM", "HeuristicLab.LibSVM", "{782DDDA3-A7A3-404E-B751-6200CE2D5EF3}"
@@ -76,5 +74,4 @@
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6} = {6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}
 		{1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB} = {1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB}
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E} = {29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}
 		{250ADE34-82FD-4BAE-86D5-985FBE589C4A} = {250ADE34-82FD-4BAE-86D5-985FBE589C4A}
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1} = {0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}
@@ -89,5 +86,4 @@
 		{3EAF1454-086D-44A2-8509-B1BA24DB1865} = {3EAF1454-086D-44A2-8509-B1BA24DB1865}
 		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A} = {3BD61258-31DA-4B09-89C0-4F71FEF5F05A}
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF} = {01BBCB5A-144A-4A7E-908E-079849E2F7CF}
 		{96E5ED5B-187D-4012-9CDA-D85CDAD38342} = {96E5ED5B-187D-4012-9CDA-D85CDAD38342}
 		{E86E215D-E3CE-4244-978D-555D4E17AC09} = {E86E215D-E3CE-4244-978D-555D4E17AC09}
@@ -238,8 +234,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.OneMax.Views-3.3", "HeuristicLab.Problems.OneMax.Views\3.3\HeuristicLab.Problems.OneMax.Views-3.3.csproj", "{4FE983A1-AAF8-4977-B9E2-52B3224510CB}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ALGLIB-2.5.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\ALGLIB-2.5.0\ALGLIB-2.5.0.csproj", "{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ALGLIB-2.5.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\HeuristicLab.ALGLIB-2.5.0\HeuristicLab.ALGLIB-2.5.0.csproj", "{01BBCB5A-144A-4A7E-908E-079849E2F7CF}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "LibSVM-1.6.3", "HeuristicLab.ExtLibs\HeuristicLab.LibSVM\1.6.3\LibSVM-1.6.3\LibSVM-1.6.3.csproj", "{A16F23B5-FB62-499E-A831-26953AA56FE2}"
 EndProject
@@ -280,4 +272,10 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.VariableNeighborhoodSearch-3.3", "HeuristicLab.Algorithms.VariableNeighborhoodSearch\3.3\HeuristicLab.Algorithms.VariableNeighborhoodSearch-3.3.csproj", "{E4CFB0C3-0589-4893-B38E-8BEDF885C765}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ALGLIB-3.1.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\HeuristicLab.ALGLIB-3.1.0\HeuristicLab.ALGLIB-3.1.0.csproj", "{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ALGLIB-3.1.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\ALGLIB-3.1.0\ALGLIB-3.1.0.csproj", "{FC841674-62A7-4055-BE91-E41944B6C606}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ParallelEngine-3.3", "HeuristicLab.ParallelEngine\3.3\HeuristicLab.ParallelEngine-3.3.csproj", "{00814351-4AB8-4088-9B99-F62787B89E93}"
 EndProject
 Global
@@ -1026,28 +1024,4 @@
 		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x86.ActiveCfg = Release|x86
 		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x86.Build.0 = Release|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x64.ActiveCfg = Debug|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x64.Build.0 = Debug|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x86.ActiveCfg = Debug|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x86.Build.0 = Debug|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|Any CPU.Build.0 = Release|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x64.ActiveCfg = Release|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x64.Build.0 = Release|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x86.ActiveCfg = Release|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x86.Build.0 = Release|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x64.ActiveCfg = Debug|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x64.Build.0 = Debug|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x86.ActiveCfg = Debug|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x86.Build.0 = Debug|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|Any CPU.Build.0 = Release|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x64.ActiveCfg = Release|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x64.Build.0 = Release|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x86.ActiveCfg = Release|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x86.Build.0 = Release|x86
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1266,4 +1240,40 @@
 		{E4CFB0C3-0589-4893-B38E-8BEDF885C765}.Release|x86.ActiveCfg = Release|x86
 		{E4CFB0C3-0589-4893-B38E-8BEDF885C765}.Release|x86.Build.0 = Release|x86
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Debug|x64.ActiveCfg = Debug|x64
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Debug|x64.Build.0 = Debug|x64
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Debug|x86.ActiveCfg = Debug|x86
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Debug|x86.Build.0 = Debug|x86
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Release|Any CPU.Build.0 = Release|Any CPU
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Release|x64.ActiveCfg = Release|x64
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Release|x64.Build.0 = Release|x64
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Release|x86.ActiveCfg = Release|x86
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}.Release|x86.Build.0 = Release|x86
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Debug|x64.ActiveCfg = Debug|x64
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Debug|x64.Build.0 = Debug|x64
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Debug|x86.ActiveCfg = Debug|x86
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Debug|x86.Build.0 = Debug|x86
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Release|Any CPU.Build.0 = Release|Any CPU
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Release|x64.ActiveCfg = Release|x64
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Release|x64.Build.0 = Release|x64
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Release|x86.ActiveCfg = Release|x86
+		{FC841674-62A7-4055-BE91-E41944B6C606}.Release|x86.Build.0 = Release|x86
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Debug|x64.ActiveCfg = Debug|x64
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Debug|x64.Build.0 = Debug|x64
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Debug|x86.ActiveCfg = Debug|x86
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Debug|x86.Build.0 = Debug|x86
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Release|Any CPU.Build.0 = Release|Any CPU
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Release|x64.ActiveCfg = Release|x64
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Release|x64.Build.0 = Release|x64
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Release|x86.ActiveCfg = Release|x86
+		{00814351-4AB8-4088-9B99-F62787B89E93}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -1286,7 +1296,6 @@
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18} = {0A3CE05D-4FCD-40A4-9001-D57627554BBC}
 		{4ABA047D-46DD-4608-9E4A-41C5F92FDBB1} = {F94E41E4-F25F-4302-8486-0BEF121CF5C8}
-		{F1A195C9-98CD-47C6-9B74-3344EB258C5D} = {F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E} = {F1A195C9-98CD-47C6-9B74-3344EB258C5D}
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF} = {F1A195C9-98CD-47C6-9B74-3344EB258C5D}
+		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}
+		{FC841674-62A7-4055-BE91-E41944B6C606} = {F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}
 		{16A50D44-107B-4601-A291-3B6870CD919D} = {782DDDA3-A7A3-404E-B751-6200CE2D5EF3}
 		{A16F23B5-FB62-499E-A831-26953AA56FE2} = {16A50D44-107B-4601-A291-3B6870CD919D}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/ShakingOperators/VehicleRoutingShakingOperator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/ShakingOperators/VehicleRoutingShakingOperator.cs	(revision 6093)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/ShakingOperators/VehicleRoutingShakingOperator.cs	(revision 6093)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Encodings.General;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+
+namespace HeuristicLab.Problems.VehicleRouting {
+  [Item("VRPShakingOperator", "A shaking operator for VNS that applies available mutation operators.")]
+  [StorableClass]
+  public class VehicleRoutingShakingOperator : ShakingOperator<IVRPManipulator>, IVRPMultiNeighborhoodShakingOperator, IGeneralVRPOperator, IStochasticOperator {
+    #region Parameters
+    public ILookupParameter<IVRPEncoding> VRPToursParameter {
+      get { return (ILookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    }
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public ILookupParameter<IVRPProblemInstance> ProblemInstanceParameter {
+      get { return (LookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
+    }
+
+    public IVRPProblemInstance ProblemInstance {
+      get { return ProblemInstanceParameter.ActualValue; }
+    }
+
+    #endregion
+
+    [StorableConstructor]
+    protected VehicleRoutingShakingOperator(bool deserializing) : base(deserializing) { }
+    protected VehicleRoutingShakingOperator(VehicleRoutingShakingOperator original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VehicleRoutingShakingOperator(this, cloner);
+    }
+    public VehicleRoutingShakingOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<IVRPEncoding>("VRPTours", "The vrp tour encoding to shake."));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator that will be used for stochastic shaking operators."));
+      Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The VRP problem instance"));
+     
+      foreach (IVRPManipulator shaker in ApplicationManager.Manager.GetInstances<IVRPManipulator>().OrderBy(x => x.Name))
+        if (!(shaker is MultiVRPSolutionManipulator)) Operators.Add(shaker);
+    }
+
+    #region Wiring of some parameters
+    protected override void Operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IVRPManipulator>> e) {
+      base.Operators_ItemsAdded(sender, e);
+      ParameterizeOperators(e.Items);
+    }
+
+    protected override void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IVRPManipulator>> e) {
+      base.Operators_ItemsReplaced(sender, e);
+      ParameterizeOperators(e.Items);
+    }
+
+    private void ParameterizeOperators(IEnumerable<IndexedItem<IVRPManipulator>> items) {
+      if (items.Any()) {
+        foreach (IStochasticOperator op in items.Select(x => x.Value).OfType<IStochasticOperator>())
+          op.RandomParameter.ActualName = RandomParameter.Name;
+        foreach (IVRPManipulator op in items.Select(x => x.Value).OfType<IVRPManipulator>()) {
+          op.VRPToursParameter.ActualName = VRPToursParameter.Name;
+          if (op.ProblemInstanceParameter != null) op.ProblemInstanceParameter.ActualName = ProblemInstanceParameter.Name;
+        }
+      }
+    }
+    #endregion
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 6092)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 6093)
@@ -181,4 +181,5 @@
     <Compile Include="Encodings\General\Moves\VRPMoveEvaluator.cs" />
     <Compile Include="Encodings\General\PermutationEncoding.cs" />
+    <Compile Include="Encodings\General\ShakingOperators\VehicleRoutingShakingOperator.cs" />
     <Compile Include="Encodings\General\TourEncoding.cs" />
     <Compile Include="Encodings\GVR\Crossovers\GVRCrossover.cs" />
@@ -242,4 +243,5 @@
     <Compile Include="Interfaces\IVRPCreator.cs" />
     <Compile Include="Interfaces\IVRPMoveOperator.cs" />
+    <Compile Include="Interfaces\IVRPMultiNeighborhoodShakingOperator.cs" />
     <Compile Include="Interfaces\IVRPOperator.cs" />
     <Compile Include="Interfaces\IVRPEncoding.cs" />
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs	(revision 6093)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs	(revision 6093)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.VehicleRouting.Interfaces {
+  public interface IVRPMultiNeighborhoodShakingOperator : IMultiNeighborhoodShakingOperator, IVRPOperator {
+    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+  }
+}
Index: /branches/VRP/HeuristicLab/3.3/Files.txt
===================================================================
--- /branches/VRP/HeuristicLab/3.3/Files.txt	(revision 6092)
+++ /branches/VRP/HeuristicLab/3.3/Files.txt	(revision 6093)
@@ -40,4 +40,5 @@
 HeuristicLab.Optimization.Views\3.3:HeuristicLab.Optimization.Views-3.3.dll
 HeuristicLab.Optimizer\3.3:HeuristicLab.Optimizer-3.3.dll
+HeuristicLab.ParallelEngine\3.3:HeuristicLab.ParallelEngine-3.3.dll
 HeuristicLab.Parameters\3.3:HeuristicLab.Parameters-3.3.dll
 HeuristicLab.Parameters.Views\3.3:HeuristicLab.Parameters.Views-3.3.dll
@@ -71,7 +72,7 @@
 
 ;External Libraries
-HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\ALGLIB-2.5.0:ALGLIB-2.5.0.dll
-HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\HeuristicLab.ALGLIB-2.5.0:HeuristicLab.ALGLIb-2.5.0.dll
-HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\HeuristicLab.ALGLIB-2.5.0:ALGLIB License-2.5.0.txt
+HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\ALGLIB-3.1.0:ALGLIB-3.1.0.dll
+HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\HeuristicLab.ALGLIB-3.1.0:HeuristicLab.ALGLIB-3.1.0.dll
+HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\HeuristicLab.ALGLIB-3.1.0:ALGLIB License-3.1.0.txt
 HeuristicLab.ExtLibs\HeuristicLab.LibSVM\1.6.3\HeuristicLab.LibSVM-1.6.3:HeuristicLab.LibSVM-1.6.3.dll
 HeuristicLab.ExtLibs\HeuristicLab.LibSVM\1.6.3\HeuristicLab.LibSVM-1.6.3:LibSVM-1.6.3.dll